local tide = 0;
local point, relativeTo, relativePoint, xOfs, yOfs;
local width, height;
local move = true;
local width = 200;
local height = 60;
local active = true;

local MyStatusBar = CreateFrame("StatusBar", "Tideguard", UIParent)
MyStatusBar:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar")
MyStatusBar:GetStatusBarTexture():SetHorizTile(false)
MyStatusBar:SetMinMaxValues(0, 40000)
MyStatusBar:SetWidth(width)
MyStatusBar:SetHeight(height)
MyStatusBar:SetValue(0);
MyStatusBar:SetPoint("CENTER",UIParent,"CENTER")
MyStatusBar:SetStatusBarColor(0,1,0)
MyStatusBar:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
                                            edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
                                            tile = true, tileSize = 32, edgeSize = 8, 
                                            insets = { left = 2, right = 2, top = 2, bottom = 2 }
                                            })
MyStatusBar:SetBackdropColor(0,0,0,1)
MyStatusBar:SetMovable(true)
MyStatusBar:EnableMouse(true)
MyStatusBar:RegisterForDrag("LeftButton")
MyStatusBar:SetScript("OnDragStart", MyStatusBar.StartMoving)
MyStatusBar:SetScript("OnDragStop", function(self, event, ...)
	point, relativeTo, relativePoint, xOfs, yOfs = MyStatusBar:GetPoint()
		tgVar["point"] = point;
		tgVar["relativePoint"] = relativePoint;
		tgVar["xOfs"] = xOfs;
		tgVar["yOfs"] = yOfs;
		tgVar["move"] = move;
	MyStatusBar:StopMovingOrSizing();
	end
)
--MyStatusBar:SetScript("OnDragStop", MyStatusBar.StopMovingOrSizing)

-- create a frame where we put our stuff
local f=CreateFrame("Frame",nil,MyStatusBar)
f:SetSize(288,100) -- lazy and gave an arbitrary width. should maybe resize
f:SetPoint("CENTER",MyStatusBar)

f.text = f:CreateFontString(nil,"OVERLAY","QuestFont_Shadow_Huge")
f.text:SetAllPoints(true)
f.text:SetJustifyH("CENTER")
f.text:SetJustifyV("MIDDLE")
f.text:SetTextColor(1,1,1,1)
f.text:SetText(tide.."/40000")

-----------Slash---------------
local function MyAddonCommands(msg, editbox)
	
	local params = {};
	local count = 1;
	
	for i in string.gmatch(msg, "%S+") do
		params[count] = i;
		count = count + 1;
	end
	local value = tonumber(params[2]);
	
	if(params[1] == "height") then
		if(value and (value > 20)) then
			height = value;
			tgVar["height"] = height;
			MyStatusBar:SetHeight(value);
		else
			print("Wrong value. Must be a number >20");
		end
	elseif(params[1] == "width") then
		if(value and (value > 20)) then
			width = value;
			tgVar["width"] = width;
			MyStatusBar:SetWidth(value);
		else
			print("Wrong value. Must be a number >100");
		end
	elseif(params[1] == "show") then
		if(active) then
			MyStatusBar:Show();
		end
	elseif(params[1] == "hide") then
		MyStatusBar:Hide();
	elseif(params[1] == "reset") then
		MyStatusBar:SetValue(0);
		tide=0;
		f.text:SetText(tide.."/40000");
	elseif(params[1] == "movable") then
		if(value and (value ==1)) then
			MyStatusBar:SetMovable(true);
			move = true;
			tgVar["move"] = true;
		elseif (value and (value ==0)) then
			MyStatusBar:SetMovable(false);
			move = false;
			tgVar["move"] = false;
		else
			print("Wrong value. Must be 0 to deactivate or 1 to activate moving!");
		end
	else
		print("Unknown Command!");
	end
end

SLASH_TIDEGUARD1 = '/tideguard'

SlashCmdList["TIDEGUARD"] = MyAddonCommands   -- add /tideguard to command list

------------Saving--------------
local EventFrame = CreateFrame("Frame")
EventFrame:RegisterEvent("PLAYER_LOGIN")
EventFrame:SetScript("OnEvent", function(self,event,...) 
	if( event == "PLAYER_LOGIN" ) then
	local playerClass, englishClass = UnitClass("player");
	if(englishClass ~= "SHAMAN") then
		print("No Shaman here. Tideguard will sleep")
		active = false;
	end
	
	if tgVar == nil then  --  I know it doesn't exist. so set it's default
			print("Fresh Installation! Welcome to Tideguard!");
			tgVar = {}
			tgVar["width"] = width;
			tgVar["height"] = height;
			point, relativeTo, relativePoint, xOfs, yOfs = MyStatusBar:GetPoint();
			tgVar["point"] = point;
			tgVar["relativePoint"] = relativePoint;
			tgVar["xOfs"] = xOfs;
			tgVar["yOfs"] = yOfs;
			tgVar["move"] = move;
			
		else -- It's already set
			width = tgVar["width"];
			height = tgVar["height"];
			point = tgVar["point"];
			relativePoint = tgVar["relativePoint"];
			local xOfs = tgVar["xOfs"];
			yOfs = tgVar["yOfs"];
			move = tgVar["move"];
			
			MyStatusBar:SetWidth(width)
			MyStatusBar:SetHeight(height)
			MyStatusBar:SetPoint(point, xOfs, yOfs); --TODO
			MyStatusBar:SetMovable(move);
		end
	end
end
)
------------Precheck------------
local PreCheckFrame = CreateFrame("Frame")
PreCheckFrame:RegisterEvent("PLAYER_ALIVE")
PreCheckFrame:SetScript("OnEvent", function(self,event,...) 
		if(GetSpecialization()==3) then
			MyStatusBar:Show();
		else
			MyStatusBar:Hide();
		end
	end
)

------------Handling------------
function Tideguard_eventHandler(self, event, arg1, linid, id, ...)
	if(active) then
		if(event == "UNIT_SPELLCAST_SUCCEEDED") then

			if(arg1=="player") then

				local costTable = GetSpellPowerCost(id)[1];
				
				if(costTable) then
					local cost = costTable.cost;
					
					if(costTable.type == 0) then
					
						Tideguard_updateTide(self,cost);
						
					end
				end
			end
		elseif( event == "ACTIVE_TALENT_GROUP_CHANGED") then
			if(GetSpecialization()==3) then
				tide = 0;
				MyStatusBar:SetValue(0);
				f.text:SetText(tide.."/40000");
				MyStatusBar:Show();
			else
				MyStatusBar:Hide();
			end
		end
	end
	
end


function Tideguard_updateTide(self,cost)
	tide = tide + cost;
	if( tide >= 40000 ) then
		tide = tide - 40000;
	end
	f.text:SetText(tide.."/40000");
	MyStatusBar:SetValue(tide);
end